#property copyright "Scriptong"
#property link      "http://autograf.dp.ua"

#property indicator_chart_window

extern string A1 = "    ";
extern int    upOffset = 25;
extern int    downOffset = 25;

extern string A2 = "    ";
extern color  upColor = Blue;
extern color  downColor = Red;

extern string A3 = "  ";
extern color  nonActiveLabelColor = Gainsboro;

extern string A4 = "   (1-5)";
extern int    labelSize = 3;

extern string A5 = "    ";
extern int    lineLength = 15;

extern string A6 = " - SMS    (  1)";
extern int    smsAmount = 1;

extern string A7 = "  Email";
extern string eMailSubject = "Price Alert";

extern string A8 = " ";
extern int    i_textSize = 12;

extern string A9 = "  ";
extern string i_textFont = "Courier New";

//    ,      
#define UPLINE     "UP"                            //   /
#define DOWNLINE   "DOWN"                          //    /
#define LABEL_SIGN "LABEL_"                        //   
#define LINE_SIGN  "LINE_"                         //   
#define TEXT_SIGN  "TEXT_"                         //   


//   
#define NO_CHANGES  0                              //   
#define IS_CHANGES  1                              //  
#define IS_DRAG     2                              //    


string prefix = "SMSBP_";                          //    ..
                                                   // ..
bool activate;                                     //    

double g_upLabelPrice,                             //    ..
                                                   // ..
       g_dnLabelPrice;                             //    ..
                                                   // ..
       
datetime g_upLabelTime,                            //    ..
                                                   // ..
         g_dnLabelTime;                            //    ..
                                                   // ..
       
int    g_smsUpCnt,                                 // -  SMS ..
                                                   // ..  
       g_smsDnCnt;                                 // -  SMS ..
                                                   // ..  
       
bool   g_upStatus,                                 //   :
                                                   //  true - 
                                                   //  false -  
       g_dnStatus;                                 //   :
                                                   //  true - 
                                                   //  false -  
//+-------------------------------------------------------------------------------------+
//| Custom indicator initialization function                                            |
//+-------------------------------------------------------------------------------------+
int init()
{
// - 1 - ==   ====================================================
   activate = false;                               //  
   if (!TuningParametersCheck())                   //      ..
      return(0);                                   // .. , ..
                                                   // ..  
   activate = true;                                //  
// - 1 - ==   =============================================================
 
// - 2 - ==       ================================
   g_upLabelTime = Time[0];                        //   
   g_upLabelPrice = MarketInfo(Symbol(), MODE_ASK) + upOffset*Point;//   
   g_upStatus = false;                             //   
   ShowPriceLabel(UPLINE, g_upLabelTime, g_upLabelPrice, upColor);//  
   ShowTrendLine(UPLINE, g_upLabelTime, g_upLabelPrice, upColor);//  
// - 2 - ==   =============================================================

// - 3 - ==       =================================
   g_dnLabelTime = Time[0];                        //   
   g_dnLabelPrice = MarketInfo(Symbol(), MODE_BID) - downOffset*Point;//  ..
                                                   // ..
   g_dnStatus = false;                             //   
   ShowPriceLabel(DOWNLINE, g_dnLabelTime, g_dnLabelPrice, downColor);//  
   ShowTrendLine(DOWNLINE, g_dnLabelTime, g_dnLabelPrice, downColor);//  
// - 3 - ==   =============================================================
   
   WindowRedraw();                                 //   -  

   return(0);
}
//+-------------------------------------------------------------------------------------+
//| Custom indicator deinitialization function                                          |
//+-------------------------------------------------------------------------------------+
int deinit()
{
   for (int i = ObjectsTotal() - 1; i >= 0; i--)   //    ..
      if (StringSubstr(ObjectName(i), 0, StringLen(prefix)) == prefix)// ..
         ObjectDelete(ObjectName(i));
   return(0);
}
//+-------------------------------------------------------------------------------------+
//|                                                |
//+-------------------------------------------------------------------------------------+
bool TuningParametersCheck()
{
   string name = WindowExpertName();
   if (upOffset < 1)
   {
      Alert(name, ":  upOffset     1.",
                  "   250.");
      upOffset = 250;
   }
   if (downOffset < 1)
   {
      Alert(name, ":  downOffset     1.",
                  "   250.");
      downOffset = 250;
   }
   if (labelSize < 1 || labelSize > 5)
   {
      Alert(name, ":  labelSize      1  5.",
                  "   3.");
      labelSize = 3;
   }
   if (lineLength < 1)
   {
      Alert(name, ":  lineLength    1.",
                  "   15.");
      lineLength = 3;
   }
   if (smsAmount < 1)
   {
      Alert(name, ":  smsAmount    .",
                  "   2.");
      smsAmount = 2;
   }
   if (nonActiveLabelColor == upColor)
   {
      Alert(name, ":          .");
      return(false);
   }
   if (nonActiveLabelColor == downColor)
   {
      Alert(name, ":          .");
      return(false);
   }
   
   return(true);
}
//+-------------------------------------------------------------------------------------+
//|                                                   |
//+-------------------------------------------------------------------------------------+
bool IsDrag(string name)
{
   if (ObjectFind(name) == 0)                      //    , ..
   {     
      ObjectDelete(name);                          // .. 
      if (ObjectFind(name) == 0)                   //     , 
         return(true);                             // ..    
   }
   return(false);                                  //  
}
//+-------------------------------------------------------------------------------------+
//|    " "                                               |
//+-------------------------------------------------------------------------------------+
bool ShowPriceLabel(string sName, datetime time, double price, color cColor)
{
   string name = prefix + LABEL_SIGN + sName;      //  
   if (IsDrag(name))                               //    - 
      return(false);

   ObjectCreate(name, OBJ_ARROW, 0, time, price);  //   - 
   ObjectSet(name, OBJPROP_ARROWCODE, 5);          //    
   ObjectSet(name, OBJPROP_COLOR, cColor);         //  
   ObjectSet(name, OBJPROP_WIDTH, labelSize);      //  
   return(true);
}
//+-------------------------------------------------------------------------------------+
//|                                                          |
//+-------------------------------------------------------------------------------------+
datetime GetTimeOfLineEnd(datetime time)
{
   int bar = iBarShift(NULL, 0, time);             //    ( )..
                                                   // .. 
   if (bar - lineLength >= 0)                      //      
      return(Time[bar - lineLength]);              // .. ,  ..
                                                   // ..    

   return(Time[0] + (lineLength - bar)*Period()*60);//     
                                                   //    
}
//+-------------------------------------------------------------------------------------+
//|    " "                                             |
//+-------------------------------------------------------------------------------------+
bool ShowTrendLine(string sName, datetime time, double price, color cColor)
{
   string name = prefix + LINE_SIGN + sName;       //  
   if (IsDrag(name))                               //    - 
      return(false);

   ObjectCreate(name, OBJ_TREND, 0, time, price,   //   -  
                GetTimeOfLineEnd(time), price);    
   ObjectSet(name, OBJPROP_COLOR, cColor);         //  
   ObjectSet(name, OBJPROP_RAY, false);            //    
   return(true);
}
//+-------------------------------------------------------------------------------------+
//|    ""                                                       |
//+-------------------------------------------------------------------------------------+
void ShowText(string sName, datetime time, double price, 
              int upOffset, int dnOffset, color cColor)
{
   string name = prefix + TEXT_SIGN + sName;       //  
   datetime showTime = time + (GetTimeOfLineEnd(time) - time)/2;
   string text = dnOffset + " .";
   if (sName == UPLINE)
      text = upOffset + " .";

   if (ObjectFind(name) < 0)
   {
      ObjectCreate(name, OBJ_TEXT, 0, showTime,     //   - 
                   price);
      ObjectSetText(name, text, i_textSize, i_textFont, cColor);
      return;
   }

   ObjectSetText(name, text, i_textSize, i_textFont, cColor);
   ObjectMove(name, 0, showTime, price);
}
//+-------------------------------------------------------------------------------------+
//|              |
//+-------------------------------------------------------------------------------------+
bool IsPointMoving(string name, string sign, int numPoint, double samplePrice,
                   datetime sampleTime)
{
   if (numPoint == 0)                              //   0  ..
   {                                               // .. 
      int objPrice = OBJPROP_PRICE1;
      int objTime = OBJPROP_TIME1;
   }
   else                                            //   1 - 
   {
      objPrice = OBJPROP_PRICE2;
      objTime = OBJPROP_TIME2;
   }
   
   double price = GetLinePrice(sign, objPrice);    //   ..
                                                   // .. 
   datetime time = GetLineTime(sign, objTime);     //   ..
                                                   // .. 
   if (price != samplePrice || time != sampleTime) //       
      return(true);                                // ..,   

   return(false);                                  //    ..
                                                   // ..
}
//+-------------------------------------------------------------------------------------+
//|                                              |
//+-------------------------------------------------------------------------------------+
double GetLabelPrice(string name)
{
   return (ObjectGet(prefix + LABEL_SIGN + name, OBJPROP_PRICE1));
}
//+-------------------------------------------------------------------------------------+
//|                                           |
//+-------------------------------------------------------------------------------------+
datetime GetLabelTime(string name)
{
   return (ObjectGet(prefix + LABEL_SIGN + name, OBJPROP_TIME1));
}
//+-------------------------------------------------------------------------------------+
//|                                                      |
//+-------------------------------------------------------------------------------------+
double GetColor(string sign, string name)
{
   return (ObjectGet(prefix + sign + name, OBJPROP_COLOR));
}
//+-------------------------------------------------------------------------------------+
//|                                              |
//+-------------------------------------------------------------------------------------+
double GetLinePrice(string name, int num)
{
   return (ObjectGet(prefix + LINE_SIGN + name, num));
}
//+-------------------------------------------------------------------------------------+
//|                                           |
//+-------------------------------------------------------------------------------------+
double GetLineTime(string name, int num)
{
   return (ObjectGet(prefix + LABEL_SIGN + name, num));
}
//+-------------------------------------------------------------------------------------+
//|                        |
//+-------------------------------------------------------------------------------------+
void SaveCurOffset(string sign, int& curUpOffset, int& curDnOffset, double labelPrice)
{
   double point = MarketInfo(Symbol(), MODE_POINT);
   if (point <= 0)
      return;
      
   if (sign == UPLINE)
      curUpOffset = (labelPrice - MarketInfo(Symbol(), MODE_ASK))/point;

   if (sign == DOWNLINE)
      curDnOffset = (MarketInfo(Symbol(), MODE_BID) - labelPrice)/point;
}
//+-------------------------------------------------------------------------------------+
//|                                     |
//+-------------------------------------------------------------------------------------+
int CheckLabelAndHerLine(string sign,              //   (  )
                         datetime& labelTime,      //    ..
                                                   // .. 
                         double& labelPrice,       //    ..
                                                   // .. 
                         bool& status,             //    
                         int& smsCnt,              //   SMS 
                         color clr)                //  
{
   static int curUpOffset = -1, curDnOffset = -1;
   if (curUpOffset < 0 && curDnOffset < 0)
   {
      curUpOffset = upOffset;
      curDnOffset = downOffset;
   }

   int isChanges = NO_CHANGES;                     // ,    
// - 1 - ==         ===============
   string name = prefix + LABEL_SIGN + sign;       //  
   // - 1.1 - ==   =======================================================
   if (ObjectFind(name) == 0)                      //  
   {
      double tempPrice = GetLabelPrice(sign);      //    
      datetime tempTime = GetLabelTime(sign);      //    
      color cColor = GetColor(LABEL_SIGN, sign);   //   
      if (status &&                                //     ..
          (tempPrice != labelPrice || tempTime != labelTime))// ..   ..
      {                                            // ..,    ..
         smsCnt = 0;                               // .. ,  ..
         status = false;                           // .. 
         cColor = clr;
         ObjectSet(name, OBJPROP_COLOR, cColor);   //     ..
         SaveCurOffset(sign, curUpOffset, curDnOffset, tempPrice);
         isChanges = IS_CHANGES;                   // ..    
      }
      if (!status && tempPrice != labelPrice)      //    , ..
         SaveCurOffset(sign, curUpOffset,          // ..  , ..
                       curDnOffset, tempPrice);    // ..  ..
                                                   // ..   
      labelPrice = tempPrice;                      //    
      labelTime = tempTime;                        //    
   }
   // - 1.1 - ==   ========================================================

   // - 1.2 - ==    ====================================================
   else                                            //    ( .. 
   {                                               // ..  ..
                                                   // ..)
      if (status)                                  //   ,   -..
         cColor = nonActiveLabelColor;             // ..
      else                                         //   - 
         cColor = clr;
      ShowPriceLabel(sign, labelTime, labelPrice,  //  ,  ..
                     cColor);                      // .., ..   
      isChanges = IS_CHANGES;                      //   
   }
   // - 1.2 - ==   ========================================================
// - 1 - ==   =============================================================

// - 2 - ==         =============
   ShowText(sign, labelTime, labelPrice, curUpOffset, curDnOffset, cColor);
// - 2 - ==   =============================================================
   
// - 3 - ==         ===============
   name = prefix + LINE_SIGN + sign;               //  
   if (ObjectFind(name) == 0)                      //  
      if (!IsPointMoving(name, sign, 0, labelPrice,//     ..
                         labelTime) &&             // ..    ..
          !IsPointMoving(name, sign, 1, labelPrice,// ..   , ..
                         GetTimeOfLineEnd(labelTime)))// ..  ..
         return(isChanges);                        // .. isChanges
         
   if (!ShowTrendLine(sign, labelTime, labelPrice, cColor))//   ..
      return(IS_DRAG);                             // ..   ,  ..
                                                   // ..  
   return(IS_CHANGES);                             //  
// - 3 - ==   =============================================================
}
//+-------------------------------------------------------------------------------------+
//|  SMS                                                                        |
//+-------------------------------------------------------------------------------------+
void SendSMS(double price, string dir)
{
   SendMail(eMailSubject, "Price Level " + dir + 
            " " + DoubleToStr(price, Digits) + 
            " (" + TimeToStr(TimeCurrent()) + ")");
}
//+-------------------------------------------------------------------------------------+
//|    Ask                                    |
//+-------------------------------------------------------------------------------------+
void BreakUp()
{
   if (g_smsUpCnt >= smsAmount)                    // - SMS   -
      return;                                      //   
      
   double labelPrice = GetLabelPrice(UPLINE);      //    
   if (labelPrice - Ask < Point)                   //   Ask   ..
   {                                               // ..  , ..
      SendSMS(labelPrice, "buy");                  // .. SMS,
      g_smsUpCnt++;                                // ..  SMS
      if (g_smsUpCnt >= smsAmount)                 //   SMS ..
      {                                            // .. , ..
         g_upStatus = true;                        // ..   
         ObjectSet(prefix + LABEL_SIGN + UPLINE, OBJPROP_COLOR, nonActiveLabelColor);
         ObjectSet(prefix + LINE_SIGN + UPLINE, OBJPROP_COLOR, nonActiveLabelColor);
         WindowRedraw();
      }
   }
}
//+-------------------------------------------------------------------------------------+
//|    Bid                                     |
//+-------------------------------------------------------------------------------------+
void BreakDown()
{
   if (g_smsDnCnt >= smsAmount)                    // - SMS   -
      return;                                      //   
      
   double labelPrice = GetLabelPrice(DOWNLINE);    //    
   if (Bid - labelPrice < Point)                   //   Bid   ..
   {                                               // ..  , ..
      SendSMS(labelPrice, "sell");                 // .. SMS,
      g_smsDnCnt++;                                // ..  SMS
      if (g_smsDnCnt >= smsAmount)                 //   SMS ..
      {                                            // .. , ..
         g_dnStatus = true;                        // ..   
         ObjectSet(prefix + LABEL_SIGN + DOWNLINE, OBJPROP_COLOR, nonActiveLabelColor);
         ObjectSet(prefix + LINE_SIGN + DOWNLINE, OBJPROP_COLOR, nonActiveLabelColor);
         WindowRedraw();
      }
   }
}
//+-------------------------------------------------------------------------------------+
//| Custom indicator iteration function                                                 |
//+-------------------------------------------------------------------------------------+
int start()
{
// - 1 - ==   ? ===============================================
   if (!activate)
      return(0);
// - 1 - ==   =============================================================
      
// - 2 - ==       ======================================
   int resUp = CheckLabelAndHerLine(UPLINE, 
                                    g_upLabelTime, 
                                    g_upLabelPrice, 
                                    g_upStatus, 
                                    g_smsUpCnt,
                                    upColor);
   if (resUp == IS_DRAG)                           //     ..
      return(0);                                   // ..,   ..
                                                   // ..   
// - 2 - ==   =============================================================

// - 3 - ==       ========================================
   int resDn = CheckLabelAndHerLine(DOWNLINE, 
                                    g_dnLabelTime, 
                                    g_dnLabelPrice, 
                                    g_dnStatus, 
                                    g_smsDnCnt,
                                    downColor);
                                  
   if (resDn == IS_DRAG)                           //     ..
      return(0);                                   // ..,   ..
                                                   // ..   
// - 3 - ==   =============================================================
      
// - 4 - ==       =====================================
   BreakUp();                                      //   
   BreakDown();                                    //   
// - 4 - ==   =============================================================
      
// - 5 - ==    - ,    ====================
   if (resUp == IS_CHANGES || resDn == IS_CHANGES)
      WindowRedraw();
// - 5 - ==       =====================================

   return(0);
}

